#include <windows.h>
#include <winreg.h>
#include <stdio.h>


#define SZ_FTDIBUS          "SYSTEM\\CurrentControlSet\\Enum\\FTDIBUS"
#define SZ_PORT_NAME        "PortName"


void EnumerateKey(HKEY hKey,unsigned char *pszKeyName);


void main(void)
{
    unsigned char pszName[MAX_PATH] = "";
    DWORD dwNameLen = MAX_PATH;
    HKEY hStartKey = HKEY_LOCAL_MACHINE;
    HKEY hKey;
    DWORD dwSubKeys;
    DWORD dwResult;
    DWORD i;

    //
    // open FTDIBUS key
    //

    dwResult = RegOpenKeyEx(
                    hStartKey,
                    SZ_FTDIBUS,
                    0L,
                    KEY_READ,
                    &hKey
                    );

    if (ERROR_SUCCESS == dwResult) {

        //
        // get number of subkeys under FTDIBUS
        //

        dwResult = RegQueryInfoKey(
                        hKey,
                        NULL,NULL,
                        NULL,
                        &dwSubKeys,
                        NULL,
                        NULL,
                        NULL,
                        NULL,NULL,NULL,NULL
                        );

        //
        // enumerate the subkeys under FTDIBUS
        //

        for (i = 0; i < dwSubKeys; i++) {

            dwResult = RegEnumKeyEx(hKey,i,pszName,&dwNameLen,NULL,NULL,NULL,NULL);

            if (ERROR_SUCCESS == dwResult) {
                printf("FTDIBUS\\%s : ",pszName);
                EnumerateKey(hKey,pszName);
            }

            pszName[0] = '\0';
            dwNameLen = MAX_PATH;

        }

        //
        // close FTDIBUS key
        //

        RegCloseKey(hKey);

    }
    else {

        printf("Can't open %s\\%s (%d)\n",hStartKey,SZ_FTDIBUS,dwResult);

    }

}

void EnumerateKey(HKEY hParentKey,unsigned char *pszKeyName)
{
    unsigned char pszName[MAX_PATH] = "";
    DWORD dwNameLen = MAX_PATH;
    DWORD dwResult;
    DWORD dwKeyCount;
    DWORD dwValueCount;
    DWORD i,gotIt;
    HKEY hKey;
    char Buf[256];
    DWORD BufLen;
    DWORD BufType;

    dwResult = RegOpenKeyEx(hParentKey,pszKeyName,0L,KEY_READ,&hKey);

    if (ERROR_SUCCESS != dwResult) {
        printf("Can't open %s\\%s (%d)\n",hParentKey,pszKeyName,dwResult);
        return;
    }

//    printf("%s\n",pszKeyName);

    //
    // get number of subkeys and values for this key
    //

    dwResult = RegQueryInfoKey(
                    hKey,
                    NULL,NULL,
                    NULL,
                    &dwKeyCount,
                    NULL,
                    NULL,
                    &dwValueCount,
                    NULL,NULL,NULL,NULL
                    );

    if (ERROR_SUCCESS != dwResult)
        return;

    //
    // enumerate values and search for UpperFilters
    //

    for (i = 0, gotIt = 0; i < dwValueCount && gotIt == 0; i++) {

        BufLen = 256;
        dwResult = RegEnumValue(hKey,i,pszName,&dwNameLen,NULL,&BufType,Buf,&BufLen);

        if (ERROR_SUCCESS == dwResult) {

            //
            // test for UpperFilters value
            //

            if (strcmpi(pszName,SZ_PORT_NAME) == 0) {
                printf("%s\n",Buf);
                gotIt = 1;
            }


        }

        pszName[0] = '\0';
        dwNameLen = MAX_PATH;

    }

    //
    // enumerate keys
    //

    for (i = 0; i < dwKeyCount && gotIt == 0; i++) {

        dwResult = RegEnumKeyEx(hKey,i,pszName,&dwNameLen,NULL,NULL,NULL,NULL);

        if (ERROR_SUCCESS == dwResult) {
            EnumerateKey(hKey,pszName);
        }

        pszName[0] = '\0';
        dwNameLen = MAX_PATH;

    }

    RegCloseKey(hKey);

}


